/*
 * header file for gw
 */

#define VERSION	"1.31"

/* if this is defined, we terminate instead of giving warnings */
/*#define FASCIST*/

/* if this file is writeable, then log entries will be made */
#define LOGFILE	"/usr/local/home/fadden/.gwlog"
extern FILE *logfp;

/* deal with funky SVR3 signal mechanism */
#ifdef _UTS
# define SYSV
#endif

#ifdef SYSV
# define SIGNAL(sig,action) sigset(sig, action)
#else
# define SIGNAL(sig,action) signal(sig, action)
#endif


/*
 * stuff
 */
extern char *malloc();
extern struct passwd *getpwuid();

extern int verbose;

int connectMachine( /* char *machine, int port */ );
int listenSocket( /* port */ );
int acceptConnection( /* socket */ );
int gwrite( /* int fd, char *buf, int bytes */ );

typedef struct gateway {
    int protocol;
    int listenPort;
    char listenMachine[80];	/* UDP only */
    int socket;
    char foreignMachine[80];
    int foreignPort;
    char addr[32];		/* UDP only - must hold a struct sockaddr_in */
    struct gateway *gwPair;	/* UDP only */
    struct gateway *next;
};

typedef struct connection {
    int readSock;
    int writeSock;
    struct connection *next;
};

#define PROTO_TCP	1	/* simple TCP connection */
#define PROTO_UDP	2	/* server->client UDP connection */
#define PROTO_UDP2	3	/* client->server UDP connection (needs from) */

